︠8e731a7d-4eac-4dc3-82e2-95c77053e4eei︠
%html
<html>
<H1>Solving an equation Picard's way</H1>
<H2>Introduction:  Solving $x^2-x-1=0$</H2>
<p>If we are trying to solve an equation like $x^2-x-1=0$, we could try $x^2=x+1$, so that $x=1+\frac{1}{x}$</p>
<p>And we can substitute the value of x again $x=1+\frac{1}{1+\frac{1}{x}}$</p>
<p>And again, and again...</p>
<p>$x+1+\frac{1}{1+\frac{1}{1+\frac{1}{x}}}$</p>
<p>We could, finally, now write</p>
<p>$x=1 + \frac{1}{1 + \frac{1}{1 + \frac{1}{1 + \frac{1}{1 + \ldots}}}}$</p>
<H2>Picard's way</H2>

<p>Hence to solve $x^2-x-1=0$</p>
<p>We first write it as $x=1+\frac{1}{x}$</p>
<p>And then we transform it as $x_1=1$ and $x_{n+1}=1+\frac{1}{x_n}$</p>
<p>And then we get...</p>
<p> $x_1=1$; $x_2=1+\frac{1}{x_1}$; $x_3=1+\frac{1}{x_2}$; $x_4=1+\frac{1}{x_3}$</p>
<p> $x_1=1$; $x_2=1+1/1$; $x_3=1+\frac{1}{1+\frac{1}{1}}$; $x_4=1+\frac{1}{1+\frac{1}{1+\frac{1}{1}}}$</p>
<p> If the sequence $\{x_n\}_{n\in\mathbb{N}}$ converges, an exercise in calculus shows that $\displaystyle{\lim_{x\rightarrow \infty} x_n=x}$ is a solution to the problem.</p>
<p> In this case the sequence converges, other problems like $x=1-x$ lead to non-convergent sequences, and thus they do not lead to solutions...</p>
<H2>Now, an interactive demonstration</H2>
</html>

︡091fd1cc-1999-4b5d-a632-cd29f6ed25b1︡{"html": "<html>\r\n<H1>Solving an equation Picard's way</H1>\r\n<H2>Introduction:  Solving $x^2-x-1=0$</H2>\r\n<p>If we are trying to solve an equation like $x^2-x-1=0$, we could try $x^2=x+1$, so that $x=1+\\frac{1}{x}$</p>\r\n<p>And we can substitute the value of x again $x=1+\\frac{1}{1+\\frac{1}{x}}$</p>\r\n<p>And again, and again...</p>\r\n<p>$x+1+\\frac{1}{1+\\frac{1}{1+\\frac{1}{x}}}$</p>\r\n<p>We could, finally, now write</p>\r\n<p>$x=1 + \\frac{1}{1 + \\frac{1}{1 + \\frac{1}{1 + \\frac{1}{1 + \\ldots}}}}$</p>\r\n<H2>Picard's way</H2>\r\n\r\n<p>Hence to solve $x^2-x-1=0$</p>\r\n<p>We first write it as $x=1+\\frac{1}{x}$</p>\r\n<p>And then we transform it as $x_1=1$ and $x_{n+1}=1+\\frac{1}{x_n}$</p>\r\n<p>And then we get...</p>\r\n<p> $x_1=1$; $x_2=1+\\frac{1}{x_1}$; $x_3=1+\\frac{1}{x_2}$; $x_4=1+\\frac{1}{x_3}$</p>\r\n<p> $x_1=1$; $x_2=1+1/1$; $x_3=1+\\frac{1}{1+\\frac{1}{1}}$; $x_4=1+\\frac{1}{1+\\frac{1}{1+\\frac{1}{1}}}$</p>\r\n<p> If the sequence $\\{x_n\\}_{n\\in\\mathbb{N}}$ converges, an exercise in calculus shows that $\\displaystyle{\\lim_{x\\rightarrow \\infty} x_n=x}$ is a solution to the problem.</p>\r\n<p> In this case the sequence converges, other problems like $x=1-x$ lead to non-convergent sequences, and thus they do not lead to solutions...</p>\r\n<H2>Now, an interactive demonstration</H2>\r\n</html>"}︡
︠e7f6e4d3-c259-41a6-af16-af539f7c3105︠
#So we apply the next one.
#Let's see how it works:
def fromoldtonew(xold):
    return 1+1/xold    
    
@interact
def f(initial=1,n=(1,20,1)):
    html('This program starts with $x_1='+str(initial)+'$ and then iterates applying the function $x_{n+1}=1+\\frac{1}{x_n}$')
    xold=initial
    for i in range(n-1):
        xnew=fromoldtonew(xold)
        xold=xnew
    print html(xold)
    print xold.n()
    print html('Notice that regardless of the initial value, the process approximates the real root $1.618$')
︡e141cd86-c52f-4ba8-aa1e-8f7a51df9b48︡︡
︠f7257074-18e9-4143-8c79-8ecff57ae02di︠
%html
<html>
<H2>Solving a differential equation</H2>


<p>In a similar way, lets try to solve the initial value problem</p>

<p>$\frac{dy}{dx}=y$</p>
<p>$y(0)=1$</p>

<p>This corresponds to $y(x)-y(0)=\int_{0}^{x}y(s)ds$</p>
<p>Solving, and substituing the value of y(0), we get:</p>
<p>$y(x)=\int_{0}^{x}y(s)ds+1$</p>
<p>And we can substitute again...</p>
<p>$y(s)=\int_{0}^{x}\left(\int_{0}^{s}y(s_1)ds_1+1\right)+sds$</p>
<H2>Solving a Differential Equation in Picard's way</H2>
<p>We can do again the same thing we did for the other equation</p>
<p>$y_1=1$; the constant function 1, which does satisfy that $y(0)=1$</p>
<p>$y_{n+1}=\int_{0}^{x}y_n(s)ds+1$</p>

<H2>Now, an interactive demonstration</H2>
</html>

︡00c6b30a-2000-4101-808f-ec8043429c20︡{"html": "<html>\r\n<H2>Solving a differential equation</H2>\r\n\r\n\r\n<p>In a similar way, lets try to solve the initial value problem</p>\r\n\r\n<p>$\\frac{dy}{dx}=y$</p>\r\n<p>$y(0)=1$</p>\r\n\r\n<p>This corresponds to $y(x)-y(0)=\\int_{0}^{x}y(s)ds$</p>\r\n<p>Solving, and substituing the value of y(0), we get:</p>\r\n<p>$y(x)=\\int_{0}^{x}y(s)ds+1$</p>\r\n<p>And we can substitute again...</p>\r\n<p>$y(s)=\\int_{0}^{x}\\left(\\int_{0}^{s}y(s_1)ds_1+1\\right)+sds$</p>\r\n<H2>Solving a Differential Equation in Picard's way</H2>\r\n<p>We can do again the same thing we did for the other equation</p>\r\n<p>$y_1=1$; the constant function 1, which does satisfy that $y(0)=1$</p>\r\n<p>$y_{n+1}=\\int_{0}^{x}y_n(s)ds+1$</p>\r\n\r\n<H2>Now, an interactive demonstration</H2>\r\n</html>"}︡
︠00b21ca5-a61a-49aa-ad43-8c7b71d0d2e9︠
#Restart the worksheet
s=var('s')
y=var('y')
#So we apply the next one.
#Let's see how it works:    
@interact
def g(fxy='y',x0=0,y0=1,initial=1,n=(1,9,1),assume_x_positive=True):
    fxy=sage_eval(fxy,locals={'x':x,'y':y})
    if assume_x_positive:
        assume(x>0)
    fxy=fxy+x-x+y-y
    r=str(latex(fxy))
    html('We are trying to solve the initial value problem')
    html(r'$\frac{dy}{dx}='+str(latex(fxy))+'$')
    html(r'$y('+str(x0)+')='+str(y0)+'$')
    html(r'Which is equivalent to the problem')
    html(r'$y=\int_{'+str(x0)+'}^x'+r.replace('y','y(x)').replace('x','s')+'ds+'+str(y0))
    r=r.replace('y','y_n(x)')
    r=r.replace('x','s')
    def fromoldtonew(yold):
        return integrate(fxy(y=yold(x=s),x=s),s,x0,x)+y0    
    html('This program starts with $x_1='+str(initial)+'$')
    html(r'and then iterates applying $y_{n+1}=\int_{'+str(x0)+'}^x'+r+'ds+'+str(y0))
    xold=initial+x-x
    print html(r'Initial=')
    show(initial)
    for i in range(n-1):
        xnew=fromoldtonew(xold)
        xold=xnew
        show(xold)
    print html(r'after $%s$ iterates we get'%str(n))
    show(xold)
    print html(r'That is, we get')
    show(xold)
︡b6c0b4b6-c795-44b5-93f9-cc37f54257e3︡︡
︠b6307622-2ca4-4f58-9181-0bb8b7a42fdai︠
%html
<html>
<p>Notice that this, indeed converges to the power series expansion of $e^x$, regardless of the initial function!</p>

︡7e65d45a-cf1c-4f78-a25a-0f4d31cb5cbb︡{"html": "<html>\r\n<p>Notice that this, indeed converges to the power series expansion of $e^x$, regardless of the initial function!</p>"}︡
︠0879dc9e-204a-4016-80fd-4f8042f178f8︠
html(r'$\frac{1}{x}')
︡bb1efa51-92ac-4dc2-b996-1e8aa05cf83d︡{"html": "<font color='black'><span class=\"math\">\\frac{1}{x}</span></font>"}︡
